
/* mpz_cmp(u,v) -- Compare U, V.  Return postive, zero, or negative
   based on if U > V, U == V, or U < V.

Copyright (C) 1991 Free Software Foundation, Inc.

This file is part of the GNU MP Library.

The GNU MP Library is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

The GNU MP Library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with the GNU MP Library; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */



/* mp.h -- Definitions for Berkeley compatible multiple precision functions.

Copyright (C) 1991, 1993 Free Software Foundation, Inc.

This file is part of the GNU MP Library.

The GNU MP Library is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

The GNU MP Library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with the GNU MP Library; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */









/*
   stddef.h    Standard definitions
 
   Copyright by WATCOM International Corp. 1988-1995.  All rights reserved.
 */




 typedef unsigned size_t;






typedef unsigned short wchar_t;




 
  
 #line 38 "/usr/watcom/10.5/usr/include/stddef.h"




 #line 45 "/usr/watcom/10.5/usr/include/stddef.h"
  typedef int   ptrdiff_t;
 





 extern int *__threadid(void);  /* pointer to thread id */ 
 








typedef struct
{
  long int alloc;		/* Number of limbs allocated and pointed
				   to by the D field.  */ 
  long int size;		/* abs(SIZE) is the number of limbs
				   the last field points to.  If SIZE
				   is negative this is a negative
				   number.  */ 
  unsigned long int *d;		/* Pointer to the limbs.  */ 
} __MP_INT;





void mp_set_memory_functions (void *(*) (size_t),
			      void *(*) (void *, size_t, size_t),
			      void (*) (void *, size_t));
 __MP_INT  *itom (signed short int);
 __MP_INT  *xtom (const char *);
void move (const  __MP_INT  *,  __MP_INT  *);
void madd (const  __MP_INT  *, const  __MP_INT  *,  __MP_INT  *);
void msub (const  __MP_INT  *, const  __MP_INT  *,  __MP_INT  *);
void mult (const  __MP_INT  *, const  __MP_INT  *,  __MP_INT  *);
void mdiv (const  __MP_INT  *, const  __MP_INT  *,  __MP_INT  *,  __MP_INT  *);
void sdiv (const  __MP_INT  *, signed short int,  __MP_INT  *, signed short int *);
void msqrt (const  __MP_INT  *,  __MP_INT  *,  __MP_INT  *);
void pow (const  __MP_INT  *, const  __MP_INT  *, const  __MP_INT  *,  __MP_INT  *);
void rpow (const  __MP_INT  *, signed short int,  __MP_INT  *);
void gcd (const  __MP_INT  *, const  __MP_INT  *,  __MP_INT  *);
int mcmp (const  __MP_INT  *, const  __MP_INT  *);
void min ( __MP_INT  *);
void mout (const  __MP_INT  *);
char *mtox (const  __MP_INT  *);
void mfree ( __MP_INT  *);


/* __MP_H__ */



/* gmp.h -- Definitions for GNU multiple precision functions.

Copyright (C) 1991, 1993 Free Software Foundation, Inc.

This file is part of the GNU MP Library.

The GNU MP Library is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

The GNU MP Library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with the GNU MP Library; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */










typedef unsigned long int	mp_limb;
typedef long int		mp_limb_signed;
typedef mp_limb *		mp_ptr;

typedef const mp_limb *		mp_srcptr;
typedef long int		mp_size;

/* Structure for rational numbers.  Zero is represented as 0/any, i.e.
   the denominator is ignored.  Negative numbers have the sign in
   the numerator.  */
typedef struct
{
   __MP_INT  num;
   __MP_INT  den;
} MP_RAT;


void mp_set_memory_functions (void *(*) (size_t),
			      void *(*) (void *, size_t, size_t),
			      void (*) (void *, size_t));

/* Integer (i.e. Z) routines.  */

void mpz_init ( __MP_INT  *);
void mpz_set ( __MP_INT  *, const  __MP_INT  *);
void mpz_set_ui ( __MP_INT  *, unsigned long int);
void mpz_set_si ( __MP_INT  *, signed long int);
int mpz_set_str ( __MP_INT  *, const char *, int);
void mpz_init_set ( __MP_INT  *, const  __MP_INT  *);
void mpz_init_set_ui ( __MP_INT  *, unsigned long int);
void mpz_init_set_si ( __MP_INT  *, signed long int);
int mpz_init_set_str ( __MP_INT  *, const char *, int);
unsigned long int mpz_get_ui (const  __MP_INT  *);
signed long int mpz_get_si (const  __MP_INT  *);
char * mpz_get_str (char *, int, const  __MP_INT  *);
void mpz_clear ( __MP_INT  *);
void * _mpz_realloc ( __MP_INT  *, mp_size);
void mpz_add ( __MP_INT  *, const  __MP_INT  *, const  __MP_INT  *);
void mpz_add_ui ( __MP_INT  *, const  __MP_INT  *, unsigned long int);
void mpz_sub ( __MP_INT  *, const  __MP_INT  *, const  __MP_INT  *);
void mpz_sub_ui ( __MP_INT  *, const  __MP_INT  *, unsigned long int);
void mpz_mul ( __MP_INT  *, const  __MP_INT  *, const  __MP_INT  *);
void mpz_mul_ui ( __MP_INT  *, const  __MP_INT  *, unsigned long int);
void mpz_div ( __MP_INT  *, const  __MP_INT  *, const  __MP_INT  *);
void mpz_div_ui ( __MP_INT  *, const  __MP_INT  *, unsigned long int);
void mpz_mod ( __MP_INT  *, const  __MP_INT  *, const  __MP_INT  *);
void mpz_mod_ui ( __MP_INT  *, const  __MP_INT  *, unsigned long int);
void mpz_divmod ( __MP_INT  *,  __MP_INT  *, const  __MP_INT  *, const  __MP_INT  *);
void mpz_divmod_ui ( __MP_INT  *,  __MP_INT  *, const  __MP_INT  *, unsigned long int);
void mpz_mdiv ( __MP_INT  *, const  __MP_INT  *, const  __MP_INT  *);
void mpz_mdiv_ui ( __MP_INT  *, const  __MP_INT  *, unsigned long int);
void mpz_mmod ( __MP_INT  *, const  __MP_INT  *, const  __MP_INT  *);
unsigned long int mpz_mmod_ui ( __MP_INT  *, const  __MP_INT  *, unsigned long int);
void mpz_mdivmod ( __MP_INT  *,  __MP_INT  *, const  __MP_INT  *, const  __MP_INT  *);
unsigned long int mpz_mdivmod_ui ( __MP_INT  *,  __MP_INT  *, const  __MP_INT  *,
				  unsigned long int);
void mpz_sqrt ( __MP_INT  *, const  __MP_INT  *);
void mpz_sqrtrem ( __MP_INT  *,  __MP_INT  *, const  __MP_INT  *);
int mpz_perfect_square_p (const  __MP_INT  *);
int mpz_probab_prime_p (const  __MP_INT  *, int);
void mpz_powm ( __MP_INT  *, const  __MP_INT  *, const  __MP_INT  *, const  __MP_INT  *);
void mpz_powm_ui ( __MP_INT  *, const  __MP_INT  *, unsigned long int, const  __MP_INT  *);
void mpz_pow_ui ( __MP_INT  *, const  __MP_INT  *, unsigned long int);
void mpz_fac_ui ( __MP_INT  *, unsigned long int);
void mpz_gcd ( __MP_INT  *, const  __MP_INT  *, const  __MP_INT  *);
void mpz_gcdext ( __MP_INT  *,  __MP_INT  *,  __MP_INT  *, const  __MP_INT  *, const  __MP_INT  *);
void mpz_neg ( __MP_INT  *, const  __MP_INT  *);
void mpz_com ( __MP_INT  *, const  __MP_INT  *);
void mpz_abs ( __MP_INT  *, const  __MP_INT  *);
int mpz_cmp (const  __MP_INT  *, const  __MP_INT  *);
int mpz_cmp_ui (const  __MP_INT  *, unsigned long int);
int mpz_cmp_si (const  __MP_INT  *, signed long int);
void mpz_mul_2exp ( __MP_INT  *, const  __MP_INT  *, unsigned long int);
void mpz_div_2exp ( __MP_INT  *, const  __MP_INT  *, unsigned long int);
void mpz_mod_2exp ( __MP_INT  *, const  __MP_INT  *, unsigned long int);
void mpz_and ( __MP_INT  *, const  __MP_INT  *, const  __MP_INT  *);
void mpz_ior ( __MP_INT  *, const  __MP_INT  *, const  __MP_INT  *);
void mpz_xor ( __MP_INT  *, const  __MP_INT  *, const  __MP_INT  *);


void mpz_array_init ( __MP_INT  [], size_t, mp_size);
void mpz_random ( __MP_INT  *, mp_size);
void mpz_random2 ( __MP_INT  *, mp_size);
size_t mpz_size (const  __MP_INT  *);
size_t mpz_sizeinbase (const  __MP_INT  *, int);

/* Rational (i.e. Q) routines.  */

void mpq_init (MP_RAT *);
void mpq_clear (MP_RAT *);
void mpq_set (MP_RAT *, const MP_RAT *);
void mpq_set_ui (MP_RAT *, unsigned long int, unsigned long int);
void mpq_set_si (MP_RAT *, signed long int, unsigned long int);
void mpq_add (MP_RAT *, const MP_RAT *, const MP_RAT *);
void mpq_sub (MP_RAT *, const MP_RAT *, const MP_RAT *);
void mpq_mul (MP_RAT *, const MP_RAT *, const MP_RAT *);
void mpq_div (MP_RAT *, const MP_RAT *, const MP_RAT *);
void mpq_neg (MP_RAT *, const MP_RAT *);
int mpq_cmp (const MP_RAT *, const MP_RAT *);
void mpq_inv (MP_RAT *, const MP_RAT *);
void mpq_set_num (MP_RAT *, const  __MP_INT  *);
void mpq_set_den (MP_RAT *, const  __MP_INT  *);
void mpq_get_num ( __MP_INT  *, const MP_RAT *);
void mpq_get_den ( __MP_INT  *, const MP_RAT *);

/* Low level positive-integer (i.e. N) routines.  */

mp_limb mpn_add (mp_ptr, mp_srcptr, mp_size, mp_srcptr, mp_size);
mp_size mpn_sub (mp_ptr, mp_srcptr, mp_size, mp_srcptr, mp_size);
mp_size mpn_mul (mp_ptr, mp_srcptr, mp_size, mp_srcptr, mp_size);
mp_size mpn_div (mp_ptr, mp_ptr, mp_size, mp_srcptr, mp_size);
mp_limb mpn_divmod_1 (mp_ptr, mp_srcptr, mp_size, mp_limb);
mp_limb mpn_mod_1 (mp_srcptr, mp_size, mp_limb);
mp_limb mpn_lshift (mp_ptr, mp_srcptr, mp_size, unsigned int);
mp_size mpn_rshift (mp_ptr, mp_srcptr, mp_size, unsigned int);
mp_size mpn_rshiftci (mp_ptr, mp_srcptr, mp_size, unsigned int, mp_limb);
mp_size mpn_sqrt (mp_ptr, mp_ptr, mp_srcptr, mp_size);
int mpn_cmp (mp_srcptr, mp_srcptr, mp_size);

/* __STDC__ */#line 301 "gmp.h"

/* __GMP_H__ */


/* Include file for internal GNU MP types and definitions.

Copyright (C) 1991 Free Software Foundation, Inc.

This file is part of the GNU MP Library.

The GNU MP Library is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

The GNU MP Library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with the GNU MP Library; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.   */



/* Empty */
void *alloca();





/* gmp-mparam.h -- Compiler/machine parameter header file.

    THIS FILE WAS CREATED BY A PROGRAM.  DON'T EDIT IT! 

Copyright (C) 1991 Free Software Foundation, Inc.

This file is part of the GNU MP Library.

The GNU MP Library is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License as
published by the Free Software Foundation; either version 2, or
(at your option) any later version.

The GNU MP Library is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with the GNU MP Library; see the file COPYING.  If not, write
to the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139,
USA.  */










void *malloc (size_t);
void *realloc (void *, size_t);
void free (void *);

extern void *	(*_mp_allocate_func) (size_t);
extern void *	(*_mp_reallocate_func) (void *, size_t, size_t);
extern void	(*_mp_free_func) (void *, size_t);

void *_mp_default_allocate (size_t);
void *_mp_default_reallocate (void *, size_t, size_t);
void _mp_default_free (void *, size_t);

char *_mpz_get_str (char *, int, const  __MP_INT  *);
int _mpz_set_str ( __MP_INT  *, const char *, int);
void _mpz_impl_sqrt ( __MP_INT  *,  __MP_INT  *, const  __MP_INT  *);

/* Copy NLIMBS limbs from SRC to DST.  */






/* Zero NLIMBS limbs AT DST.  */







/* Initialize the MP_INT X with space for NLIMBS limbs.
   X should be a temporary variable, and it will be automatically
   cleared out when the running function returns.  */






/* Structure for conversion between internal binary format and
   strings in base 2..36.  */
struct bases
{
  /* Number of digits in the conversion base that always fits in
     an mp_limb.  For example, for base 10 this is 10, since
     232 = 4294967296 has ten digits.  */
  int chars_per_limb;

  /* big_base is conversion_basechars_per_limb, i.e. the biggest
     number that fits a word, built by factors of conversion_base.
     Exception: For 2, 4, 8, etc, big_base is log2(base), i.e. the
     number of bits used to represent each digit in the base.  */
  mp_limb big_base;

  /* big_base_inverted is a BITS_PER_MP_LIMB bit approximation to
     1/big_base, represented as a fixed-point number.  Instead of
     dividing by big_base an application can choose to multiply
     by big_base_inverted.  */
  mp_limb big_base_inverted;

  /* log(2)/log(conversion_base) */
  float chars_per_bit_exactly;
};

extern const struct bases __mp_bases[37];


/* BERKELEY_MP */#line 38 "mpz_cmp.c"
int

mcmp (const  __MP_INT  *u, const  __MP_INT  *v)
/* BERKELEY_MP */
{
  mp_size usize = u->size;
  mp_size vsize = v->size;
  mp_size size;
  mp_size i;
  mp_limb a, b;
  mp_srcptr up, vp;

  if (usize != vsize)
    return usize - vsize;

  if (usize == 0)
    return 0;

  size =   (usize >= 0 ? usize : -usize) ;

  up = u->d;
  vp = v->d;

  i = size - 1;
  do
    {
      a = up[i];
      b = vp[i];
      i--;
      if (i < 0)
	break;
    }
  while (a == b);

  if (a == b)
    return 0;

  if ((a < b) == (usize < 0))
    return 1;
  else
    return -1;
}
