
/* mpz_pow_ui(res, base, exp) -- Set RES to BASEEXP.

Copyright (C) 1991 Free Software Foundation, Inc.

This file is part of the GNU MP Library.

The GNU MP Library is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

The GNU MP Library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with the GNU MP Library; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */


/* gmp.h -- Definitions for GNU multiple precision functions.

Copyright (C) 1991, 1993 Free Software Foundation, Inc.

This file is part of the GNU MP Library.

The GNU MP Library is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

The GNU MP Library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with the GNU MP Library; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */









/*
   stddef.h    Standard definitions
 
   Copyright by WATCOM International Corp. 1988-1995.  All rights reserved.
 */




 typedef unsigned size_t;






typedef unsigned short wchar_t;




 
  
 #line 38 "/usr/watcom/10.5/usr/include/stddef.h"




 #line 45 "/usr/watcom/10.5/usr/include/stddef.h"
  typedef int   ptrdiff_t;
 





 extern int *__threadid(void);  /* pointer to thread id */ 
 








typedef struct
{
  long int alloc;		/* Number of limbs allocated and pointed
				   to by the D field.  */ 
  long int size;		/* abs(SIZE) is the number of limbs
				   the last field points to.  If SIZE
				   is negative this is a negative
				   number.  */ 
  unsigned long int *d;		/* Pointer to the limbs.  */ 
} __MP_INT;




typedef unsigned long int	mp_limb;
typedef long int		mp_limb_signed;
typedef mp_limb *		mp_ptr;

typedef const mp_limb *		mp_srcptr;
typedef long int		mp_size;

/* Structure for rational numbers.  Zero is represented as 0/any, i.e.
   the denominator is ignored.  Negative numbers have the sign in
   the numerator.  */
typedef struct
{
   __MP_INT  num;
   __MP_INT  den;
} MP_RAT;


void mp_set_memory_functions (void *(*) (size_t),
			      void *(*) (void *, size_t, size_t),
			      void (*) (void *, size_t));

/* Integer (i.e. Z) routines.  */

void mpz_init ( __MP_INT  *);
void mpz_set ( __MP_INT  *, const  __MP_INT  *);
void mpz_set_ui ( __MP_INT  *, unsigned long int);
void mpz_set_si ( __MP_INT  *, signed long int);
int mpz_set_str ( __MP_INT  *, const char *, int);
void mpz_init_set ( __MP_INT  *, const  __MP_INT  *);
void mpz_init_set_ui ( __MP_INT  *, unsigned long int);
void mpz_init_set_si ( __MP_INT  *, signed long int);
int mpz_init_set_str ( __MP_INT  *, const char *, int);
unsigned long int mpz_get_ui (const  __MP_INT  *);
signed long int mpz_get_si (const  __MP_INT  *);
char * mpz_get_str (char *, int, const  __MP_INT  *);
void mpz_clear ( __MP_INT  *);
void * _mpz_realloc ( __MP_INT  *, mp_size);
void mpz_add ( __MP_INT  *, const  __MP_INT  *, const  __MP_INT  *);
void mpz_add_ui ( __MP_INT  *, const  __MP_INT  *, unsigned long int);
void mpz_sub ( __MP_INT  *, const  __MP_INT  *, const  __MP_INT  *);
void mpz_sub_ui ( __MP_INT  *, const  __MP_INT  *, unsigned long int);
void mpz_mul ( __MP_INT  *, const  __MP_INT  *, const  __MP_INT  *);
void mpz_mul_ui ( __MP_INT  *, const  __MP_INT  *, unsigned long int);
void mpz_div ( __MP_INT  *, const  __MP_INT  *, const  __MP_INT  *);
void mpz_div_ui ( __MP_INT  *, const  __MP_INT  *, unsigned long int);
void mpz_mod ( __MP_INT  *, const  __MP_INT  *, const  __MP_INT  *);
void mpz_mod_ui ( __MP_INT  *, const  __MP_INT  *, unsigned long int);
void mpz_divmod ( __MP_INT  *,  __MP_INT  *, const  __MP_INT  *, const  __MP_INT  *);
void mpz_divmod_ui ( __MP_INT  *,  __MP_INT  *, const  __MP_INT  *, unsigned long int);
void mpz_mdiv ( __MP_INT  *, const  __MP_INT  *, const  __MP_INT  *);
void mpz_mdiv_ui ( __MP_INT  *, const  __MP_INT  *, unsigned long int);
void mpz_mmod ( __MP_INT  *, const  __MP_INT  *, const  __MP_INT  *);
unsigned long int mpz_mmod_ui ( __MP_INT  *, const  __MP_INT  *, unsigned long int);
void mpz_mdivmod ( __MP_INT  *,  __MP_INT  *, const  __MP_INT  *, const  __MP_INT  *);
unsigned long int mpz_mdivmod_ui ( __MP_INT  *,  __MP_INT  *, const  __MP_INT  *,
				  unsigned long int);
void mpz_sqrt ( __MP_INT  *, const  __MP_INT  *);
void mpz_sqrtrem ( __MP_INT  *,  __MP_INT  *, const  __MP_INT  *);
int mpz_perfect_square_p (const  __MP_INT  *);
int mpz_probab_prime_p (const  __MP_INT  *, int);
void mpz_powm ( __MP_INT  *, const  __MP_INT  *, const  __MP_INT  *, const  __MP_INT  *);
void mpz_powm_ui ( __MP_INT  *, const  __MP_INT  *, unsigned long int, const  __MP_INT  *);
void mpz_pow_ui ( __MP_INT  *, const  __MP_INT  *, unsigned long int);
void mpz_fac_ui ( __MP_INT  *, unsigned long int);
void mpz_gcd ( __MP_INT  *, const  __MP_INT  *, const  __MP_INT  *);
void mpz_gcdext ( __MP_INT  *,  __MP_INT  *,  __MP_INT  *, const  __MP_INT  *, const  __MP_INT  *);
void mpz_neg ( __MP_INT  *, const  __MP_INT  *);
void mpz_com ( __MP_INT  *, const  __MP_INT  *);
void mpz_abs ( __MP_INT  *, const  __MP_INT  *);
int mpz_cmp (const  __MP_INT  *, const  __MP_INT  *);
int mpz_cmp_ui (const  __MP_INT  *, unsigned long int);
int mpz_cmp_si (const  __MP_INT  *, signed long int);
void mpz_mul_2exp ( __MP_INT  *, const  __MP_INT  *, unsigned long int);
void mpz_div_2exp ( __MP_INT  *, const  __MP_INT  *, unsigned long int);
void mpz_mod_2exp ( __MP_INT  *, const  __MP_INT  *, unsigned long int);
void mpz_and ( __MP_INT  *, const  __MP_INT  *, const  __MP_INT  *);
void mpz_ior ( __MP_INT  *, const  __MP_INT  *, const  __MP_INT  *);
void mpz_xor ( __MP_INT  *, const  __MP_INT  *, const  __MP_INT  *);


void mpz_array_init ( __MP_INT  [], size_t, mp_size);
void mpz_random ( __MP_INT  *, mp_size);
void mpz_random2 ( __MP_INT  *, mp_size);
size_t mpz_size (const  __MP_INT  *);
size_t mpz_sizeinbase (const  __MP_INT  *, int);

/* Rational (i.e. Q) routines.  */

void mpq_init (MP_RAT *);
void mpq_clear (MP_RAT *);
void mpq_set (MP_RAT *, const MP_RAT *);
void mpq_set_ui (MP_RAT *, unsigned long int, unsigned long int);
void mpq_set_si (MP_RAT *, signed long int, unsigned long int);
void mpq_add (MP_RAT *, const MP_RAT *, const MP_RAT *);
void mpq_sub (MP_RAT *, const MP_RAT *, const MP_RAT *);
void mpq_mul (MP_RAT *, const MP_RAT *, const MP_RAT *);
void mpq_div (MP_RAT *, const MP_RAT *, const MP_RAT *);
void mpq_neg (MP_RAT *, const MP_RAT *);
int mpq_cmp (const MP_RAT *, const MP_RAT *);
void mpq_inv (MP_RAT *, const MP_RAT *);
void mpq_set_num (MP_RAT *, const  __MP_INT  *);
void mpq_set_den (MP_RAT *, const  __MP_INT  *);
void mpq_get_num ( __MP_INT  *, const MP_RAT *);
void mpq_get_den ( __MP_INT  *, const MP_RAT *);

/* Low level positive-integer (i.e. N) routines.  */

mp_limb mpn_add (mp_ptr, mp_srcptr, mp_size, mp_srcptr, mp_size);
mp_size mpn_sub (mp_ptr, mp_srcptr, mp_size, mp_srcptr, mp_size);
mp_size mpn_mul (mp_ptr, mp_srcptr, mp_size, mp_srcptr, mp_size);
mp_size mpn_div (mp_ptr, mp_ptr, mp_size, mp_srcptr, mp_size);
mp_limb mpn_divmod_1 (mp_ptr, mp_srcptr, mp_size, mp_limb);
mp_limb mpn_mod_1 (mp_srcptr, mp_size, mp_limb);
mp_limb mpn_lshift (mp_ptr, mp_srcptr, mp_size, unsigned int);
mp_size mpn_rshift (mp_ptr, mp_srcptr, mp_size, unsigned int);
mp_size mpn_rshiftci (mp_ptr, mp_srcptr, mp_size, unsigned int, mp_limb);
mp_size mpn_sqrt (mp_ptr, mp_ptr, mp_srcptr, mp_size);
int mpn_cmp (mp_srcptr, mp_srcptr, mp_size);

/* __STDC__ */#line 301 "gmp.h"

/* __GMP_H__ */


/* Include file for internal GNU MP types and definitions.

Copyright (C) 1991 Free Software Foundation, Inc.

This file is part of the GNU MP Library.

The GNU MP Library is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

The GNU MP Library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with the GNU MP Library; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.   */



/* Empty */
void *alloca();





/* gmp-mparam.h -- Compiler/machine parameter header file.

    THIS FILE WAS CREATED BY A PROGRAM.  DON'T EDIT IT! 

Copyright (C) 1991 Free Software Foundation, Inc.

This file is part of the GNU MP Library.

The GNU MP Library is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License as
published by the Free Software Foundation; either version 2, or
(at your option) any later version.

The GNU MP Library is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with the GNU MP Library; see the file COPYING.  If not, write
to the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139,
USA.  */










void *malloc (size_t);
void *realloc (void *, size_t);
void free (void *);

extern void *	(*_mp_allocate_func) (size_t);
extern void *	(*_mp_reallocate_func) (void *, size_t, size_t);
extern void	(*_mp_free_func) (void *, size_t);

void *_mp_default_allocate (size_t);
void *_mp_default_reallocate (void *, size_t, size_t);
void _mp_default_free (void *, size_t);

char *_mpz_get_str (char *, int, const  __MP_INT  *);
int _mpz_set_str ( __MP_INT  *, const char *, int);
void _mpz_impl_sqrt ( __MP_INT  *,  __MP_INT  *, const  __MP_INT  *);

/* Copy NLIMBS limbs from SRC to DST.  */






/* Zero NLIMBS limbs AT DST.  */







/* Initialize the MP_INT X with space for NLIMBS limbs.
   X should be a temporary variable, and it will be automatically
   cleared out when the running function returns.  */






/* Structure for conversion between internal binary format and
   strings in base 2..36.  */
struct bases
{
  /* Number of digits in the conversion base that always fits in
     an mp_limb.  For example, for base 10 this is 10, since
     232 = 4294967296 has ten digits.  */
  int chars_per_limb;

  /* big_base is conversion_basechars_per_limb, i.e. the biggest
     number that fits a word, built by factors of conversion_base.
     Exception: For 2, 4, 8, etc, big_base is log2(base), i.e. the
     number of bits used to represent each digit in the base.  */
  mp_limb big_base;

  /* big_base_inverted is a BITS_PER_MP_LIMB bit approximation to
     1/big_base, represented as a fixed-point number.  Instead of
     dividing by big_base an application can choose to multiply
     by big_base_inverted.  */
  mp_limb big_base_inverted;

  /* log(2)/log(conversion_base) */
  float chars_per_bit_exactly;
};

extern const struct bases __mp_bases[37];


/* longlong.h -- definitions for mixed size 32/64 bit arithmetic.
   Copyright (C) 1991, 1992, 1993 Free Software Foundation, Inc.

   This definition file is free software; you can redistribute it
   and/or modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation; either
   version 2, or (at your option) any later version.

   This definition file is distributed in the hope that it will be
   useful, but WITHOUT ANY WARRANTY; without even the implied
   warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
   See the GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */











/* Define auxiliary asm macros.

   1) umul_ppmm(high_prod, low_prod, multipler, multiplicand)
   multiplies two unsigned long integers MULTIPLER and MULTIPLICAND,
   and generates a two unsigned word product in HIGH_PROD and
   LOW_PROD.

   2) __umulsidi3(a,b) multiplies two unsigned long integers A and B,
   and returns a long long product.  This is just a variant of umul_ppmm.

   3) udiv_qrnnd(quotient, remainder, high_numerator, low_numerator,
   denominator) divides a two-word unsigned integer, composed by the
   integers HIGH_NUMERATOR and LOW_NUMERATOR, by DENOMINATOR and
   places the quotient in QUOTIENT and the remainder in REMAINDER.
   HIGH_NUMERATOR must be less than DENOMINATOR for correct operation.
   If, in addition, the most significant bit of DENOMINATOR must be 1,
   then the pre-processor symbol UDIV_NEEDS_NORMALIZATION is defined to 1.

   4) sdiv_qrnnd(quotient, remainder, high_numerator, low_numerator,
   denominator).  Like udiv_qrnnd but the numbers are signed.  The
   quotient is rounded towards 0.

   5) count_leading_zeros(count, x) counts the number of zero-bits from
   the msb to the first non-zero bit.  This is the number of steps X
   needs to be shifted left to set the msb.  Undefined for X == 0.

   6) add_ssaaaa(high_sum, low_sum, high_addend_1, low_addend_1,
   high_addend_2, low_addend_2) adds two two-word unsigned integers,
   composed by HIGH_ADDEND_1 and LOW_ADDEND_1, and HIGH_ADDEND_2 and
   LOW_ADDEND_2 respectively.  The result is placed in HIGH_SUM and
   LOW_SUM.  Overflow (i.e. carry out) is not stored anywhere, and is
   lost.

   7) sub_ddmmss(high_difference, low_difference, high_minuend,
   low_minuend, high_subtrahend, low_subtrahend) subtracts two
   two-word unsigned integers, composed by HIGH_MINUEND_1 and
   LOW_MINUEND_1, and HIGH_SUBTRAHEND_2 and LOW_SUBTRAHEND_2
   respectively.  The result is placed in HIGH_DIFFERENCE and
   LOW_DIFFERENCE.  Overflow (i.e. carry out) is not stored anywhere,
   and is lost.

   If any of these macros are left undefined for a particular CPU,
   C macros are used.  */

/* The CPUs come in alphabetical order below.

   Please add support for more CPUs here, or improve the current support
   for the CPUs below!  */

/* __GNUC__ */#line 888 "longlong.h"










/* If this machine has no inline assembler, use C macros.  */





































/* this can't give carry */
/* but this indeed can */
/* did we get it? */
/* yes, add it in the proper pos. */






/* Define this unconditionally, so it can be used for debugging.  */













/* i.e. we didn't get carry when adding to __r1 */






















/* If udiv_qrnnd was not defined for this processor, use __udiv_qrnnd_c.  */






extern

const

unsigned char __clz_tab[];
























/* BERKELEY_MP */#line 36 "mpz_pow_ui.c"
void

rpow (const  __MP_INT  *b, signed short int e,  __MP_INT  *r)
/* BERKELEY_MP */
{
  mp_ptr rp, bp, tp, xp;
  mp_size rsize, bsize;
  int cnt, i;

  bsize =   (b->size >= 0 ? b->size : -b->size) ;

  /* Single out cases that give result == 0 or 1.  These tests are here
     to simplify the general code below, not to optimize.  */
  if (bsize == 0

      || e < 0

      )
    {
      r->size = 0;
      return;
    }
  if (e == 0)
    {
      r->d[0] = 1;
      r->size = 1;
      return;
    }

  /* Count the number of leading zero bits of the base's most
     significant limb.  */
    do { unsigned long int __xr = (b->d[bsize - 1]); unsigned int __a; if (32 <= 32) { __a = __xr < (1<<2*(32 / 4)) ? (__xr < (1<<(32 / 4)) ? 0 : (32 / 4)) : (__xr < (1<<3*(32 / 4)) ? 2*(32 / 4) : 3*(32 / 4)); } else { for (__a = 32 - 8; __a > 0; __a -= 8) if (((__xr >> __a) & 0xff) != 0) break; } (cnt) = 32 - (__clz_tab[__xr >> __a] + __a); } while (0) ;

  /* Over-estimate space requirements and allocate enough space for the
     final result in two temporary areas.  The two areas are used to
     alternately hold the input and recieve the product for mpn_mul.
     (This scheme is used to fulfill the requirements of mpn_mul; that
     the product space may not be the same as any of the input operands.)  */
  rsize = bsize * e - cnt * e /  32 ;

  rp = (mp_ptr) alloca (rsize *  4 );
  tp = (mp_ptr) alloca (rsize *  4 );
  bp = b->d;

    do { mp_size i; for (i = 0; i < (bsize); i++) (rp)[i] = (bp)[i]; } while (0) ;
  rsize = bsize;
    do { unsigned long int __xr = (e); unsigned int __a; if (32 <= 32) { __a = __xr < (1<<2*(32 / 4)) ? (__xr < (1<<(32 / 4)) ? 0 : (32 / 4)) : (__xr < (1<<3*(32 / 4)) ? 2*(32 / 4) : 3*(32 / 4)); } else { for (__a = 32 - 8; __a > 0; __a -= 8) if (((__xr >> __a) & 0xff) != 0) break; } (cnt) = 32 - (__clz_tab[__xr >> __a] + __a); } while (0) ;

  for (i =  32  - cnt - 2; i >= 0; i--)
    {
      rsize = mpn_mul (tp, rp, rsize, rp, rsize);
      xp = tp; tp = rp; rp = xp;

      if ((e & ((mp_limb) 1 << i)) != 0)
	{
	  rsize = mpn_mul (tp, rp, rsize, bp, bsize);
	  xp = tp; tp = rp; rp = xp;
	}
    }

  /* Now then we know the exact space requirements, reallocate if
     necessary.  */
  if (r->alloc < rsize)
    _mpz_realloc (r, rsize);

    do { mp_size i; for (i = 0; i < (rsize); i++) (r->d)[i] = (rp)[i]; } while (0) ;
  r->size = (e & 1) == 0 || b->size >= 0 ? rsize : -rsize;
  alloca (0);
}
